
.MODEL SMALL

_TEXT  SEGMENT WORD PUBLIC 'CODE'

       assume  cs:_TEXT, ds:DGROUP, ss:DGROUP


;.MODEL SMALL , c

; revision comm7.asm   	16/5/88
;
; The routine com1wr and com2wr have been modified so that they check 
; the state of THRE when they are called and dont now rely on the THRE
; interupt to set the ok_to_send flag. This is because sometimes the 
; program locks up and it could be because sometimes a THRE interrupt
; is missed.
;
; revision comm8.asm	16/8/88
;
; Changed so that it can be assembled using MS MASM 5.1 and linked with
; MS C 5.00.	
;
; PUBLIC functions and data are now prefixed with a _ e.g _timeout.
;
; revision comm9.asm	25/8/88
;
; Added function _chkcom() which checks for presemce of COM1 and COM2 and
; returns to c. SPlit setint and resetint into two functions each setint1 and
; setint2 so that individual com ports can be set up.
;




RBR		equ	0		; offset receive buffer 8250
THR		equ	0		; xmit holding register 8250
IER		equ	1		; interrupt enable register
IIR		equ	2		; interrupt ident register
LCR		equ	3		; line control register
MCR		equ	4		; modem control register
LSR		equ	5		; line status register
MSR		equ	6		; modem status register
SCR		equ	7		; scratch register
DLL		equ	0		; divisor latch low byte
DLM		equ	1		; divisor latch high byte
 

NIP		equ	1		; no interrupt pending
RLS		equ	6		; receiver line status interrupt
RDA		equ	4		; received data interrupt
THRE		equ	2		; transmitter holding reg empty
MS		equ	0		; modem staus interrupt

RTS_MASK	equ	2
CTS_MASK	equ	10h

RTS_CNT		equ	50		; RTS cleared 50 bytes before overflow


int1c		equ	1ch		; timer tick interrupt
int21     	equ  	21h
getvec    	equ  	35h     
setvec    	equ  	25h
com1_int	equ  	0Ch
com2_int	equ  	0Bh
com1_base	equ	3F8h
com2_base	equ	2F8h
inta01		equ	21h
inta00		equ	20h



.CODE
		PUBLIC	_setint1,_setint2,_settimer,_resetint,_setcom
		PUBLIC  _com1rd,_com1wr,_com2rd
		PUBLIC	_com2wr,_setdtr,_clrdtr,_setbrk,_clrbrk,_setrts
		PUBLIC	_clrrts,_chkbi,_timer1,_timer2
		PUBLIC	_setint1b,_rsetint1b
		PUBLIC	_l_clrbrk
       PUBLIC  _com1out,_com2out,_chkcom

       assume  cs:_TEXT, ds:DGROUP, ss:DGROUP

; ========================================================================
; ==									==
; == ROUTINE : _timer1							==
; ==									==
; == This routine sets up the value count. It is passed a value from C	==
; == which represents the timeout. The timeout generated is calculated	==
; == as value * 54.92mS. A delay between 54.92mS and 3599secs can be	==
; == produced. AFter the delay has expired the flag timeout is set to 1 ==
; ==									==
; ========================================================================

_timer1		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

		mov	ax,[bp+4]		; get value of timeout
		mov	WORD PTR _count1,ax	
		mov	WORD PTR _timeout1,0	; reset timeout flag


		pop	es
		pop	ds
		pop	bp
		ret

_timer1		ENDP

; ========================================================================
; ==									==
; == ROUTINE : _timer2							==
; ==									==
; == This routine sets up the value count. It is passed a value from C	==
; == which represents the timeout. The timeout generated is calculated	==
; == as value * 54.92mS. A delay between 54.92mS and 3599secs can be	==
; == produced. AFter the delay has expired the flag timeout is set to 1 ==
; ==									==
; ========================================================================

_timer2		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

		mov	ax,[bp+4]		; get value of timeout
		mov	WORD PTR _count2,ax	
		mov	WORD PTR _timeout2,0	; reset timeout flag


		pop	es
		pop	ds
		pop	bp
		ret

_timer2		ENDP

; ========================================================================
; ==									==
; == ROUTINE : user_tick						==
; ==									==
; == This is the interrupt service routine which handles the timer	==
; == tick interrupt. It simply dcrements the value in count and if 0	==
; == sets the timeout flag.						==
; ==									==
; ========================================================================

oldint1c_vec	dd	?

user_tick	PROC	NEAR

		sti
		pushf
		push	ax
		push	bx
		push	cx
		push	dx
		push 	si
		push 	di
		push 	es
		push	ds

		mov	ax,DGROUP
		mov	ds,ax

  		dec	WORD PTR _count1
		jnz	dec_timer2
		mov	WORD PTR _timeout1,1	; if zero then set timeout

dec_timer2:	dec	WORD PTR _count2
		jnz	user_tick1
		mov	WORD PTR _timeout2,1

user_tick1: 	pop	ds
		pop	es
		pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	ax
		popf
		jmp	cs:[oldint1c_vec]				


user_tick	ENDP

; ========================================================================
; ==									==
; == ROUTINE : com1_srv							==
; ==									==
; == This is the interrupt service routine which handles COM2		==
; == interrupts.	    						==
; ==									==
; ========================================================================
		
com1_srv	PROC	NEAR

		sti
		pushf
		push	ax
		push	bx
		push	cx
		push	dx
		push 	si
		push 	di
		push 	es
		push	ds

		mov	ax,DGROUP
		mov	ds,ax

  		mov	dx,com1_base
com1_srv1:	mov	cl,IIR
		call	read_8250		; read interrupt register
		and	al,7
		cmp	al,THRE
		je	com1_thre		; tx data reg empty int
		cmp	al,RLS
		je	com1_rls		; line status int
		cmp	al,RDA
		je	com1_rda		; recevied data available int
		cmp	al,MS		
		je	com1_ms			; modem status int
		
		mov	al,20h
		out	inta00,al		; end of interrupt for 8259
		
		pop	ds
		pop	es
		pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	ax
		popf
		iret				; all gone

	
com1_rls:
           and     BYTE PTR _com1stat,11110000b
           mov     cl,LSR
           call    read_8250
           ror     al,1
           and     al,0fh
           or      BYTE PTR _com1stat,al
           jmp     com1_srv1

com1_thre:	mov	BYTE PTR ok_to_send1,1	; data ok to transmit
		    jmp	com1_srv1
		
com1_ms:	
           and     BYTE PTR _com1stat,00001111b
           mov	    cl,MSR
		    call	read_8250
           and     al,0f0h
           or      BYTE PTR _com1stat,al
		    jmp	    com1_srv1		; clear interrupt

com1_rda:	mov	    cl,RBR
		    call	read_8250			; read data 
		    mov	    bx,WORD PTR datain_ptr1		; get input pointer
		    mov	    [bx],al				; put data in buffer
		    inc	    WORD PTR byte1count

		    cmp	    bx,offset dgroup:input_buf1 + SIZBUF -1	; end of buffer reached
		    je	    com1_rda1			; branch if end
		    inc	    bx
		    mov	    WORD PTR datain_ptr1,bx
com1_rda2:	
           cmp 	WORD PTR byte1count,SIZBUF-RTS_CNT
		    jb	    com1_rda3		; jump if byte_count < SIZBUF-RTS_CNT
           mov	    cl,MCR
		    call	read_8250
		    and	    al,NOT(RTS_MASK)	; clear RTS
 		    call	write_8250

com1_rda3:	mov	    BYTE PTR data_pres1,1		; set data present
		    jmp	    com1_srv1
		
com1_rda1:	mov	    WORD PTR datain_ptr1,offset dgroup:input_buf1
		    jmp	    com1_rda2
		
com1_srv	ENDP

; ========================================================================
; ==									==
; == ROUTINE : com2_srv							==
; ==									==
; == This is the interrupt service routine which handles COM2		==
; == interrupts.	    						==
; ==									==
; ========================================================================

com2_srv	PROC	NEAR

		sti                 ; enable ints
		pushf
		push	ax
		push	bx
		push	cx
		push	dx
		push 	si
		push 	di
		push 	es
		push	ds

		mov	ax,DGROUP
		mov	ds,ax

  		mov	dx,com2_base
com2_srv1:	
       mov	cl,IIR
		call	read_8250   ; read interrupt register
		and	al,7h
		cmp	al,THRE
		je	com2_thre		; tx data reg empty int
		cmp	al,RLS
		je	com2_rls		; line status int
		cmp	al,RDA
		je	com2_rda		; recevied data available int
		cmp	al,MS		
		je	com2_ms			; modem status int
		
		mov	al,20h
		out	inta00,al		; end of interrupt for 8259
		
		pop	ds
		pop	es
		pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	ax
		popf
		iret				    ; all gone

	
com2_rls:	
       and     BYTE PTR _com2stat,11110000b
       mov     cl,LSR
       call    read_8250
       ror     al,1
       and     al,0fh
       or      BYTE PTR _com2stat,al
       jmp     com2_srv1



com2_thre:	mov	BYTE PTR ok_to_send2,1	; data ok to transmit
		jmp	com2_srv1
		
com2_ms:	
       and     BYTE PTR _com2stat,00001111b
       mov	    cl,MSR
		call	read_8250
       and     al,0f0h
       or      BYTE PTR _com2stat,al
		jmp	    com2_srv1		; clear interrupt

		jmp	com2_srv1		    ; clear interrupt

com2_rda:	
       mov	cl,RBR
		call	read_8250			    ; read data 
       cli
       mov	bx,WORD PTR datain_ptr2		; get input pointer
		mov	[bx],al				        ; put data in buffer
		inc	WORD PTR byte2count
		cmp	bx,offset dgroup:input_buf2 + SIZBUF -1	; end of buffer reached
		je	com2_rda1			        ; branch if end
		inc	bx
		mov	WORD PTR datain_ptr2,bx
com2_rda3:	mov	BYTE PTR data_pres2,1   ; set data present
       sti                             ; enable ints
		jmp	com2_srv1
		
com2_rda1:	mov	WORD PTR datain_ptr2,offset dgroup:input_buf2
		jmp	com2_rda3
		
com2_srv	ENDP




; ========================================================================
; ==									==
; == ROUTINE : _com1rd							==
; ==									==
; == This routine reads data from the input buffer for COM1. It 	==
; == interrogates the data_pres flag. If data is present the data is 	==
; == read and the pointer updated. If the data_out pointer equals the 	==
; == data_in pointer then the data_pres flag is cleared.		==
; == This routine is called from C and returns no data (-1) or the 	==
; == character read. It returns an integer value.			==
; ==									==
;
;
;  single parameter = data adjustment fn
;                  bit 0 = 1 for reverse, ie bit 7 to bit 0
;                  bit 1 = 1 for invert.                                                            
;
; ========================================================================

_com1rd		PROC	NEAR

		push	bp
		mov	    bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

		mov	ax,-1				; set up return value
		and	BYTE PTR data_pres1,1		; is data available
		jz	_com1rd3				; no so return -1
		mov	bx,WORD PTR dataout_ptr1	; get pointer
		mov	al,[bx]				; get byte from buffer
		push	ax
		dec	WORD PTR byte1count
		cmp	bx,offset dgroup:input_buf1 + SIZBUF -1
		je	_com1rd1				; jump if at end
		inc	bx

_com1rd2:	mov	WORD PTR dataout_ptr1,bx
		cmp	bx,WORD PTR datain_ptr1		; are pointers equal
		jne	_com1rd4				; no so just return value
		mov	dx,com1_base
		mov	cl,MCR
		call	read_8250
		or	al,RTS_MASK
 		call	write_8250			; set RTS
		mov	BYTE PTR data_pres1,0		; yes, so no more data
		jmp	_com1rd4

_com1rd1:	mov	bx,offset dgroup:input_buf1		; reset to start of buffer
		jmp	_com1rd2				; check if more data

_com1rd4:	

       pop	ax                  ; character just read from buffer.
       mov     dx,[bp+4]       ;
       test    dl,1            ; bit 0 = 1 if reverse.
       jz      _com1rd5        ;
       mov     cx,8            ;
_com1rd7:                      ; shift bits 8 times
       rcl     al,1            ;
       rcr     dh,1            ;
       loop    _com1rd7        ;
       mov     al,dh           ;
_com1rd5:
       test    dl,2            ; bit 1 = 1 if invert.
       jz      _com1rd6        ;
       xor     al,0ffh         ; 

_com1rd6:                      ;
		mov	ah,0				; set up AX for return value

_com1rd3:	pop	es
		pop	ds
		pop	bp
		ret

_com1rd		ENDP

; ========================================================================
; ==									==
; == ROUTINE : _com1wr							==
; ==									==
; == This routine writes data to the 8250. The routine returns -1 if 	==
; == the ok_to_send1 flag is clear otherwise it sends the byte.		==
; == This routine is called from C.					==
; ==									==
; == modified for COMM7.
; ========================================================================


_com1wr		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

_com1wr2:	

       mov	cl,LSR
		mov	dx,com1_base
		call	read_8250

		and	al,20h			    ; is THRE set
		jnz	_com1wr3			    ; branch if THRE empty
		mov	ax,-1
		jmp	_com1wr1

_com1wr3:	mov	BYTE PTR ok_to_send1,0	; reset flag

       mov	ax,[bp+6]		    ; get byte to write in al
       mov     dx,[bp+4]       ; fn to apply to data.
       test    dl,1            ; bit 0 = 1 if reverse.
       jz      _com1wr5        ;
       mov     cx,8            ;
_com1wr7:                      ; shift bits 8 times
       rcl     al,1            ;
       rcr     dh,1            ;
       loop    _com1wr7        ;
       mov     al,dh           ;
_com1wr5:
       test    dl,2            ; bit 1 = 1 if invert.
       jz      _com1wr6        ;
       xor     al,0ffh         ; 
_com1wr6:

		mov	cl,THR
		mov	dx,com1_base
		call	write_8250

_com1wr1:	pop	es
		pop	ds
		pop	bp
		ret
		
_com1wr		ENDP





_com1out	PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

com1ou2:	
       mov	cl,LSR
		mov	dx,com1_base
		call	read_8250

		and	al,20h			; is THRE set
       jz  com1ou2         ;

com1ou3:	
       
		mov	ax,[bp+4]		; get byte to write in al
		mov	cl,THR
		mov	dx,com1_base
		call	write_8250

com1ou1:	
       pop	es
		pop	ds
		pop	bp
		ret
		
_com1out    ENDP

_com2out	PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

com2ou2:	
       mov	cl,LSR
		mov	dx,com2_base
		call	read_8250

		and	al,20h			; is THRE set
       jz  com2ou2         ;

com2ou3:	
       
		mov	ax,[bp+4]		; get byte to write in al
		mov	cl,THR
		mov	dx,com2_base
		call	write_8250

com2ou1:	
       pop	es
		pop	ds
		pop	bp
		ret
		
_com2out    ENDP
				

; ========================================================================
; ==									==
; == ROUTINE : _com2rd							==
; ==									==
; == This routine reads data from the input buffer for COM1. It 	==
; == interrogates the data_pres flag. If data is present the data is 	==
; == read and the pointer updated. If the data_out pointer equals the 	==
; == data_in pointer then the data_pres flag is cleared.		==
; == This routine is called from C and returns no data (-1) or the 	==
; == character read. It returns an integer value.			==
; ==									==
;
;
;  Single parameter = read data adjustment.
;                     bit 0 = 1 for Revers, ie bit 7 is bit 0
;                     bit 1 = 1 for Invert.
;
; ========================================================================

_com2rd		PROC	NEAR

		push	bp
       mov     bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

		mov	ax,-1				        ; set up return value
		and	BYTE PTR data_pres2,1		; is data available
		jz	_com2rd3				    ; no so return -1

       cli                             ;
		mov	bx,WORD PTR dataout_ptr2	; get pointer
		mov	al,[bx]				        ; get byte from buffer
		push	ax
		dec	WORD PTR byte2count
		cmp	bx,offset dgroup:input_buf2 + SIZBUF -1
		je	_com2rd1				    ; jump if at end
		inc	bx

_com2rd2:	
       mov	WORD PTR dataout_ptr2,bx
		cmp	bx,WORD PTR datain_ptr2		; are pointers equal
		jne	_com2rd4				    ; no so just return value
		mov	BYTE PTR data_pres2,0		; yes, so no more data
		jmp	_com2rd4

_com2rd1:	
       mov	bx,offset dgroup:input_buf2		; reset to start of buffer
		jmp	_com2rd2				; check if more data

_com2rd4:	
       sti                     ; enable ints
       pop	ax                  ; character just read from buffer.
       mov     dx,[bp+4]       ;
       test    dl,1            ; bit 0 = 1 if reverse.
       jz      _com2rd5        ;
       mov     cx,8            ;
_com2rd7:                      ; shift bits 8 times
       rcl     al,1            ;
       rcr     dh,1            ;
       loop    _com2rd7        ;
       mov     al,dh           ;
_com2rd5:
       test    dl,2            ; bit 1 = 1 if invert.
       jz      _com2rd6        ;
       xor     al,0ffh         ; 

_com2rd6:                      ;
		mov	ah,0				; set up AX for return value

_com2rd3:	
       pop	es
		pop	ds
		pop	bp
		ret

_com2rd		ENDP


; ========================================================================
; ==									==
; == ROUTINE : _com2wr							==
; ==									==
; == This routine writes data to the 8250. The routine returns -1 if 	==
; == the ok_to_send2 flag is clear otherwise it sends the byte.		==
; == This routine is called from C.					==
; ==									==
; == modified for COMM7							==
; ========================================================================

_com2wr		PROC	NEAR
		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax
		
_com2wr2:	
       mov	    cl,LSR
		mov	    dx,com2_base
		call	read_8250
		and	al,20h			        ; is THRE set
		jnz	_com2wr3			    ; branch if THRE empty
		mov	ax,-1
		jmp	_com2wr1

_com2wr3:	mov	BYTE PTR ok_to_send2,0	; reset flag

       mov	ax,[bp+6]		    ; get byte to write in al
       mov     dx,[bp+4]       ; fn to apply to data.
       test    dl,1            ; bit 0 = 1 if reverse.
       jz      _com2wr5        ;
       mov     cx,8            ;
_com2wr7:                      ; shift bits 8 times
       rcl     al,1            ;
       rcr     dh,1            ;
       loop    _com2wr7        ;
       mov     al,dh           ;
_com2wr5:
       test    dl,2            ; bit 1 = 1 if invert.
       jz      _com2wr6        ;
       xor     al,0ffh         ; 
_com2wr6:
		mov	cl,THR
		mov	dx,com2_base
		call	write_8250

_com2wr1:	
       pop	es
		pop	ds
		pop	bp
		ret
		
_com2wr		ENDP
		


; ========================================================================
; ==									==
; == ROUTINE : _setint1							==
; ==									==
; == Sets up interrupt vectors for COM1 interrupt so that it vectors 	==
; == to com1_srv routine. Sets up input and output buffer pointers to 	==
; == point to beginning of buffer for com1. Enables IRQ4 interrupt	==
; ==									==
; ========================================================================

_setint1	PROC	NEAR

; save registers for C

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

		or 	BYTE PTR intsset,1	; com1 interrupt set
	
; set up input buffer for com1 

		mov	WORD PTR datain_ptr1,offset dgroup:input_buf1
		mov	WORD PTR dataout_ptr1,offset dgroup:input_buf1
		mov	BYTE PTR data_pres1,0
		mov	WORD PTR byte1count,0
		
		mov	BYTE PTR ok_to_send1,1

; get com1 int vector and save in memory

	      	mov  	ah,getvec      ;get com1 int vector in ES:BX
          	mov  	al,com1_int
	       	int  	21h
          
          	mov  	WORD PTR oldcom1_vec,bx  ;save in memory
          	mov  	ax,es
          	mov  	WORD PTR oldcom1_vec + 2,ax

; set com1 vector to point to com1_srv 

		mov	ax,cs
		mov	ds,ax

          	mov  	dx,offset com1_srv
		mov  	ah,setvec
          	mov  	al,com1_int
	        int  	21h
 
		in	al,inta01		; read 8259 mask
		and	al,0efh	 		; enable irq4
		out	inta01,al

		pop	es
		pop	ds
		pop	bp
		ret

_setint1	ENDP


; ========================================================================
; ==									==
; == ROUTINE : _setint2							==
; ==									==
; == Sets up interrupt vectors for COM2 interrupt so that it vectors 	==
; == to com2_srv routine. Sets up input and output buffer pointers to 	==
; == point to beginning of buffer for com2. Enables IRQ3 interrupt	==
; ==									==
; ========================================================================

_setint2	PROC	NEAR

; save registers for C

		push	bp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

		or	BYTE PTR intsset,2	; com2 interrupt set

; set up input buffer for com2 

		mov	WORD PTR datain_ptr2,offset dgroup:input_buf2
		mov	WORD PTR dataout_ptr2,offset dgroup:input_buf2
		mov	BYTE PTR data_pres2,0
		mov	BYTE PTR byte2count,0

		mov	BYTE PTR ok_to_send2,1

; get com2 int vector and save in memory

	      	mov  	ah,getvec      ;get com2 int vector in ES:BX
          	mov  	al,com2_int
	       	int  	21h
          
          	mov  	WORD PTR oldcom2_vec,bx  ;save in memory
          	mov  	ax,es
          	mov  	WORD PTR oldcom2_vec + 2,ax

 		mov	ax,cs
 		mov	ds,ax
 
           	mov  	dx,offset com2_srv
 		mov  	ah,setvec
           	mov  	al,com2_int
 	        int  	21h
 
		in	al,inta01		; read 8259 mask
		and	al,0f7h	 		; enable irq3
		out	inta01,al

		pop	es
		pop	ds
		pop	bp
		ret
 
_setint2	ENDP


;=========================================================================
;==									==
;== _setint1b								==
;==									==
;== sets up interrupt 1b						==
;=========================================================================

oldint1b	dd	?
oldint23	dd	?


_setint1b	PROC	NEAR

		push	bp
		push	ds
		push	es

		mov	ax,cs
		mov	ds,ax

	      	mov  	ah,getvec      
          	mov  	al,1bh
	       	int  	21h
          
          	mov  	WORD PTR oldint1b,bx  ;save in code memory
          	mov  	ax,es
          	mov  	WORD PTR oldint1b + 2,ax

	      	mov  	ah,getvec      
          	mov  	al,23h
	       	int  	21h
          
          	mov  	WORD PTR oldint23,bx  ;save in code memory
          	mov  	ax,es
          	mov  	WORD PTR oldint23 + 2,ax


          	mov  	dx,offset int23
		mov  	ah,setvec
          	mov  	al,23h
	        int  	21h

          	mov  	dx,offset int1b
		mov  	ah,setvec
          	mov  	al,1bh
	        int  	21h

		pop	es
		pop	ds
		pop	bp
		ret

_setint1b	ENDP 


;=========================================================================
;== _rsetint1b								==
;==									==
;=========================================================================


_rsetint1b	PROC	NEAR

		push	bp
		push	ds
		push	es
		
		mov	ax,cs
		mov	ds,ax

          	mov  	ax,WORD PTR oldint1b 	; get IP of vector
          	mov  	dx,ax
          	mov  	ax,WORD PTR oldint1b + 2	; get CS
		mov	ds,ax			  	
		mov	ah,setvec
		mov	al,1bh
		int	21h

          	mov  	ax,WORD PTR oldint23 	; get IP of vector
          	mov  	dx,ax
          	mov  	ax,WORD PTR oldint23 + 2	; get CS
		mov	ds,ax			  	
		mov	ah,setvec
		mov	al,23h
		int	21h

		pop	es
		pop	ds
		pop	bp
		ret

_rsetint1b	ENDP


;===================
;== int1b code
;====================


int23		PROC	NEAR
		iret
int23		ENDP


int1b		PROC	NEAR
		iret

int1b		ENDP




; ========================================================================
; ==									==
; == ROUTINE : _settimer						==
; ==									==
; == Sets up timer tick interrupt to point to user tick routine		==
; ==									==
; ========================================================================

_settimer	PROC	NEAR

		push	bp
		push	ds
		push	es

		mov	ax,DGROUP
		mov	ds,ax

		or	BYTE PTR intsset,4	; timer interrupt set	

; get user timer tick interrupt and save in memory

		mov	ax,cs
		mov	ds,ax

	      	mov  	ah,getvec      
          	mov  	al,int1c
	       	int  	21h
          
          	mov  	WORD PTR oldint1c_vec,bx  ;save in code memory
          	mov  	ax,es
          	mov  	WORD PTR oldint1c_vec + 2,ax

; set up int1c to point to user routine

          	mov  	dx,offset user_tick
		mov  	ah,setvec
          	mov  	al,int1c
	        int  	21h

		pop	es
		pop	ds
		pop	bp
		ret

_settimer	ENDP 


; ========================================================================
; ==									==
; ==	ROUTINE	: _resetint						==
; ==									==
; ==	Called from C. It resets up the interrupt vectors for COM1 	==
; ==	COM2 and user tick depending on the value in intsset.		==
; ==									==
; ==	intsset bit 0 - 1 reinstate com1 interrupt 			==
; ==		     1 - 1 reinstate com2 interrupt			==
; ==		     2 - 1 reinstate timer tick interrupt		==
; ==									==
; ========================================================================
	
_resetint	PROC	NEAR

; push registers for C

		push	bp
		push	ds
		push	es

; set ds to point to data area

		mov	ax,DGROUP
		mov	ds,ax

; Disable 8250 interrupt sources

		mov	dx,com1_base
		mov	al,0			; byte to disable int's
		mov	cl,IER
		call	write_8250		; interrupts now off 

 		mov	dx,com2_base
 		mov	al,0			; byte to disable int's
 		mov	cl,IER
 		call	write_8250		; interrupts now off
 

; mask interrupt at 8259

		in	al,inta01		; read 8259 mask
		or	al,18h			; disable irq3 and irq4
		out	inta01,al

		test	BYTE PTR intsset,4	; was timer int set up
		jz	notimer			; dont touch vectors if not

; get old int1c vector and reinstate

		mov	ax,cs
		mov	ds,ax

          	mov  	ax,WORD PTR oldint1c_vec 	; get IP of vector
          	mov  	dx,ax
          	mov  	ax,WORD PTR oldint1c_vec + 2	; get CS
		mov	ds,ax			  	
		mov	ah,setvec
		mov	al,int1c
		int	21h


; get old com1 vector from memory and reinstate

		mov	ax,DGROUP
		mov	ds,ax

notimer:	test	BYTE PTR intsset,1		; check for com1
		jz	nocom1

          	mov  	ax,WORD PTR oldcom1_vec 	; get IP of vector
          	mov  	dx,ax
          	mov  	ax,WORD PTR oldcom1_vec + 2	; get CS
		mov	ds,ax			  	
		mov	ah,setvec
		mov	al,com1_int
		int	21h

; repeat for COM2

		mov	ax,DGROUP
		mov	ds,ax

nocom1:	test	BYTE PTR intsset,2
		jz	nocom2

          	mov  	ax,WORD PTR oldcom2_vec  	; get IP of vector
          	mov  	dx,ax
          	mov  	ax,WORD PTR oldcom2_vec	+ 2	; get CS of vector
		mov	ds,ax
		mov	ah,setvec
		mov	al,com2_int
		int	21h


; turn off DTR, RTS and OUT2 in modem control register

nocom2:	mov	dx,com1_base
		mov	al,0			; byte to clear DTR,RTS and OUT2
		mov	cl,MCR
		call	write_8250

		mov	dx,com2_base
		mov	al,0			; byte to clear DTR,RTS and OUT2
		mov	cl,MCR
		call	write_8250

		pop	es
		pop	ds
		pop	bp
		ret

_resetint	ENDP


; ========================================================================
; ==									==
; ==	ROUTINE	: _setcom						==
; ==									==
; ==	Called from C. It is passed a pointer to a data area defined 	==
; ==	below. The pointer is passed on the stack. The C program should	==
; ==	use the S model. This routine enables interrupts and so _setint	==
; ==	should be used first to set up the interrupt routines		==
; ==									==
; ==	comms port address   2F8 or 3F8		WORD			==
; ==	Line control				WORD			==
; ==	Baud rate       see table below		WORD			==
; ==									==
; ==	BAUD RATE TABLE							==
; ==									==
; ==	rate selected	parameter passed 				==
; ==									==
; ==	50		2304						==
; ==	75		1536						==
; ==	110		1047						==
; ==	300		 384						==
; ==	600		 192						==
; ==	1200		  96						==
; ==	2400		  48						==
; ==	4800		  24						==
; ==	7200		  16						==
; ==	9600		  12						==
; ==	19200		   6						==
; ==									==
; ========================================================================

_setcom		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	bx,[bp+4]		; bx points to parameter table
		mov	dx,[bx]			; get port address in dx

; disable interrupts

		mov	ax,[bx+2]		; get LCR value
		and	al,7fh			; set DLAB to 0
		mov	cl,LCR			; point to line control
		call	write_8250		; write data in al to dx + offset cl 
		
		mov	al,0			; byte to disable all 8250 int's
		mov	cl,IER
		call	write_8250		; disable interrupts

; set up divisor latches

		mov	ax,[bx+2]		; get LCR value again
		or	al,80h			; set DLAB = 1
		mov	cl,LCR
		call	write_8250		; write to line control
		mov	ax,[bx+4]		; get baud rate parameter
		mov	cl,DLL			; divisor latch low offset
		call	write_8250		; write low byte
		xchg	ah,al			; prepare to write high byte
		mov	cl,DLM
		call	write_8250

; set up line control register

		mov	ax,[bx+2]		; get LCR for final set up
		and	al,7fh			; DLAB to 0
		mov	cl,LCR			; point to LCR
		call	write_8250		; write byte

; turn on DTR, RTS and OUT2 in modem control register

		mov	al,0Bh			; byte to set DTR,RTS and OUT2
		mov	cl,MCR
		call	write_8250

; enable reveived data interrupts and THRE int's
 
  		mov	al,0fh			; byte to enable int's
   	 	mov	cl,IER
 		call	write_8250		; interrupts now on ;
 
       cmp     dx,com1_base    ;
       jne     notcom1         ;
       call    rstat1          ;
       jp      setret          ;
notcom1:
       call    rstat2

setret:


		pop	es
		pop	ds
		pop	bp
		ret
_setcom		ENDP




; 
;
;
;  Read initial value of _com1stat
;
;
;

rstat1:
       mov     dx,com1_base
       mov     cl,MSR
       call    read_8250
       and     al,11110000b
       mov     BYTE PTR _com1stat,al
       mov     cl,LSR
       call    read_8250
       ror     al,1
       and     al,0fh
       or      BYTE PTR _com1stat,al
       ret
; 
;
;
;  Read initial value of _com2stat
;
;
;

rstat2: mov     dx,com2_base
       mov     cl,MSR
       call    read_8250
       and     al,11110000b
       mov     BYTE PTR _com2stat,al
       mov     cl,LSR
       call    read_8250
       ror     al,1
       and     al,0fh
       or      BYTE PTR _com2stat,al
       ret







; ========================================================================
; ==									==
; == ROUTINE : write_8250						==
; ==									==
; == Writes the data in al to the i/o addressed by dx + offset cl	==
; == No registers except cx are affected				==
; ==									==
; ========================================================================


write_8250	PROC	NEAR
		push	dx
		mov	ch,0
		add	dx,cx			; calculate address
		out	dx,al			; write byte
		pop	dx
		ret
write_8250	ENDP


; ========================================================================
; ==									==
; == ROUTINE : read_8250						==
; ==									==
; == Reads the data into al form the i/o addressed by dx + offset cl	==
; == No registers except ax,cx are affected				==
; ==									==
; ========================================================================


read_8250	PROC	NEAR
		push	dx
		mov	ch,0
		add	dx,cx			; calculate address
		in	al,dx			; read byte
		pop	dx
		ret
read_8250	ENDP




; ========================================================================
; ==									==
; == ROUTINE	: _clrdtr						==
; ==									==
; ========================================================================

_clrdtr		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	dx,[bp+4]		; get port address in dx
		mov	cl,MCR
		call	read_8250
		and	al,0feh			; clear DTR
		call	write_8250
       cmp     dx,com1_base
       jne     notdtr1

       jp      _clrdtrx

notdtr1:
_clrdtrx:

		pop	es
		pop	ds
		pop	bp
		ret
_clrdtr		ENDP

; ========================================================================
; ==									==
; ==	ROUTINE	: _setdtr						==
; ==									==
; ========================================================================

_setdtr		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	dx,[bp+4]		; get port address in dx
		mov	cl,MCR
		call	read_8250
		or	al,1			; set DTR
		call	write_8250
       cmp     dx,com1_base
       jne     notdtr2

       jp      _setdtrx

notdtr2:
_setdtrx:


		pop	es
		pop	ds
		pop	bp
		ret

_setdtr		ENDP


; ========================================================================
; ==									==
; == ROUTINE	: _clrrts						==
; ==									==
; ========================================================================

_clrrts		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	dx,[bp+4]		; get port address in dx
		mov	cl,MCR
		call	read_8250
		and	al,0fdh			; clear RTS
		call	write_8250

       cmp     dx,com1_base
       jne     notrts1

       jp      _clrrtsx

notrts1:
_clrrtsx:


		pop	es
		pop	ds
		pop	bp
		ret
_clrrts		ENDP

; ========================================================================
; ==									==
; ==	ROUTINE	: _setrts						==
; ==									==
; ========================================================================

_setrts		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	dx,[bp+4]		; get port address in dx
		mov	cl,MCR
		call	read_8250
		or	al,2			; set RTS
		call	write_8250

       cmp     dx,com1_base
       jne     notrts2

       jp      _setrtsx

notrts2:
_setrtsx:


		pop	es
		pop	ds
		pop	bp
		ret

_setrts		ENDP

; ========================================================================
; ==									==
; == ROUTINE	: _clrbrk						==
; ==									==
; ========================================================================

_clrbrk		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	dx,[bp+4]		; get port address in dx
		mov	cl,LCR
		call	read_8250
		and	al,0bfh			; clear BREAK
		call	write_8250

		pop	es
		pop	ds
		pop	bp
		ret
_clrbrk		ENDP

; ========================================================================
; ==									==
; ==	ROUTINE	: _setbrk						==
; ==									==
; ========================================================================

_setbrk		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	dx,[bp+4]		; get port address in dx
		mov	cl,LCR
		call	read_8250
		or	al,40h			; set BREAK
		call	write_8250

		pop	es
		pop	ds
		pop	bp
		ret

_setbrk		ENDP


; ========================================================================
; ==									==
; ==	ROUTINE	: _chkbi  						==
; ==									==
; == checks status of break bit and returns non zero if set		==
; ========================================================================

_chkbi		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es

		mov	dx,[bp+4]		; get port address in dx
		mov	cl,LSR
		call	read_8250
		and	al,10h			; if set then ax<>0 on return
		mov	ah,0

		pop	es
		pop	ds
		pop	bp
		ret

_chkbi		ENDP



; ========================================================================
; ==									==
; ==	ROUTINE : chkcom						==
; ==									==
; == Checks for presence of COM1 and COM2. Returns 0 if none found	==
; ==						   1 if COM1		==
; ==						   2 if COM2		==
; ==						   3 if both		==
; ==									==
; ========================================================================

_chkcom		PROC	NEAR

		push	bp
		mov	bp,sp
		push	ds
		push	es
		
		mov	bx,0
		mov	dx,com1_base	; check ifIIR = 1
		mov	cl,IIR
		call	read_8250
		cmp	al,00000001b	
		jne	checkcom2
		mov	bx,1		; set bit 0 to indicate com1

checkcom2:	mov	dx,com2_base
		mov	cl,IIR
		call	read_8250
		cmp	al,00000001b
		jne	check_done
		or	bx,2		; set bit 1 to indicate com2

check_done:	mov	ax,bx		; set return value

		pop	es
		pop	ds
		pop	bp
		ret

_chkcom		ENDP

_l_clrbrk		PROC	NEAR
		assume	ds:BIOS

		push	ds
		mov	ax,BIOS
		mov	ds,ax

		and	KEYB_BREAK,7fh
		pop	ds
		ret

_l_clrbrk		ENDP

_TEXT      ENDS


_DATA      SEGMENT WORD    PUBLIC  'DATA'

           assume  cs:DGROUP, ds:DGROUP, ss:DGROUP

.DATA
PUBLIC	_timeout1,_timeout2,_status1,_status2,_count1,_count2,_com1stat,_com2stat

_timeout1	dw	0
_timeout2	dw	0
_status1	db	0h
_status2	db	0h
_count1		dw	0
_count2		dw	0


_com1stat   db  0       ; DCD RI DSR CTS BRK FRAME PTY OVER
_com2stat   db  0       ; ------MSR----- -------LSR--------


SIZBUF		equ	2000		; size of input buffer


oldcom1_vec	dd   	?    		; old com1 int vector address
oldcom2_vec	dd	?		; old com2 int vector address

; com1 data 

byte1count	dw	0
ok_to_send1	db	1
data_pres1	db	0		; if 0 no data received
datain_ptr1	dw	input_buf1	; pointer to data to be input into buffer
dataout_ptr1	dw	input_buf1	; pointer to data to be read out

input_buf1	db	SIZBUF dup(?)	; input buffer

; com2 data area 

byte2count	dw	0
ok_to_send2	db	1
data_pres2	db	0		; if 0 no data received
datain_ptr2	dw	input_buf2	; pointer to data to be input into buffer
dataout_ptr2	dw	input_buf2	; pointer to data to be read out

input_buf2	db	SIZBUF dup(?)	; input buffer


IER_TEMP	db	?		; used to store interrupt status	
intsset	db	0		; used to store interrupt vectors set up



_DATA      ENDS

BIOS		SEGMENT AT 40h

		org	71h
KEYB_BREAK	db	?

BIOS		ENDS




           END
		


