Program Smart; (* Smartcard *)

Uses tpCrt, AsyncX, tpString, Dos, smartU ;

CONST  inBuff =4096 ; utBuff = 128 ;

VAR
  logga         : Byte;
  lastbyte      : Byte;
  check,check1  : Byte;
  out           : String;
  sendString    : BOOLEAN;
  cnt           : Word;
  x             : integer;
  port          : INTEGER;
  i,j,n         : INTEGER;        (* Rknare i olika sammanhang *)
  f             : TEXT;
  a             : BYTE;
  outString     : string;

PROCEDURE StartUp;
VAR
   klar: BOOLEAN;
   tmp:string;
BEGIN
  lastByte:=0;
  stega:=1;
  es:=1;
  logga:=0;
  sendString:= FALSE;
  cnt:=1;
  klar:= FALSE;
  i:= 1;
  nextText:=0;
  REPEAT
    IF(Opencom(port,inBuff,utBuff)) THEN
       BEGIN
         ComParams(port,9800,8,'O',1);
         klar:=TRUE;
       END;
    Inc(i);
  UNTIL (i=10) OR (Klar=TRUE);

  IF i=10 THEN
  BEGIN
    Write('Kunde ej ppna port 1');
    delay(1000);
    HALT(1);
  END;
  ClearCom(port,'B');  (* Tm buffertar *)
  textcolor(yellow); textbackground(blue);
  ClrScr;
  Window(2,2,52,17);
  textcolor(white); textbackground(black);
  ClrScr;
  frameWindow(1,1,54,18,$1E,$1E,' SmartCard Ver 0.5@ ');
  for i:= 1 to 10 do
  begin
    str(i,tmp);
    FastWrite('F'+tmp,2+i,56,$1B);
  end;
   Fastwrite('. . . . . . . . . . 1 2 3 4 5 6 7 8 1 2 3 4 5 6 7 8 . . 1 2 3 4 5 6 7 8',20,4,$1F);

  FastWrite('    '+#27#32#24#32#25#32#26+'     < Enter >     PgUp/PgDn         L        C          T       ',24,1,$30);
  FastWrite('    Rad/Pos       Snd       Funktioner       Logg     ClrScr     Texter   ',25,1,$30);
  tangent:= #0;
  i:= 1;
END;   { startup }


FUNCTION Recieve(antal: INTEGER; timeOut: INTEGER) : BOOLEAN;
BEGIN
   Recieve:=FALSE;
   n:=1;
   REPEAT            (* Vnta tills svar har inkommit eller timeout *)
      Inc(n);
      IF ComBufferLeft(port,'i') <= inBuff-antal THEN BEGIN
         Recieve := TRUE;
         n:= timeOut;
      END ELSE
        Delay(1);
   UNTIL n = timeOut;
END;


PROCEDURE Get;
BEGIN
IF Recieve(1,10) THEN
   BEGIN
     a:=Ord(ComReadCh(port));
     a:= a XOR 255;
     a:= Kryss(a);

     if a in[$0, $4, $8] then
     begin
       if lastByte= $90 then
       begin
         Write( HexB(A),#13#10);
         if logga = 1 then Write(f,HexB(A),#13#10);
       end else
       begin
         Write( HexB(A),#32);
        if logga = 1 then Write(f,HexB(A),#32);
       end;
     end else
     begin
       Write(HexB(a),#32);
       if logga = 1 then Write(f,HexB(A),#32);
     end;
     lastByte:=a;
   END;
END;    (* Get *)


PROCEDURE Transmit;
BEGIN
   Write(#13#10,'> ');
   FOR I:=1 TO Length(out) DO
     Write(hexb(ord(out[i])));
     writeln;
   out:= Invertera(out);
   out:= Korsa(out);

   ComWritewithdelay(port,out,3);
   sendString:= FALSE;
   out:='';
END;

PROCEDURE Loggning;
begin
  logga:= logga XOR 1;
  if logga= 1 then
     FastWrite('Logg',25,50,$B0)
  else
     FastWrite('Logg',25,50,$30);
end;


PROCEDURE User;
VAR
  specKey : BOOLEAN;
BEGIN
IF KeyPressed THEN
   BEGIN
     specKey:= FALSE;
     tangent:= Readkey;
     case UpCase(tangent) of
       'C': ClrScr;
       'L': Loggning;
       'T': EditFunc;
       #13: begin
              sendString:= TRUE;
              out:=Copy(EER[es],stega,2);
              out:=tillhex(out);
              if stega < Length(EER[es])-2 then stega:=stega+2;
              Stegning;
            end;
     end;
     IF tangent = #0 THEN              (* Specialtangenter      *)
     BEGIN
       specKey:= true;
       tangent:= Readkey;
       CASE Ord(tangent) OF
          $3B.. $44: begin             (* F1-F10                *)
                       out:=TillHEX(textP.texter[ord(tangent) -$3A]);
                       sendString:= True;
                     end;
          $48: If es > 1 then Dec(es);            (* Pil upp    *)
          $4B: If stega >= 3 then stega:=stega-2; (* Vnsterpil *)
          $4D: If stega < Length(EER[es])-2 then  (* Hgerpil   *)
                  stega:=stega+2;
          $50: begin                              (* Pil ned    *)
                 If es < 32 then Inc(es);
                 If stega > Length(EER[es])-2 then stega:=1;
               end;
          $49, $51: BytText                       (* PgUp/PgDn  *)
       END;
       If Ord(tangent) in[$48, $4B, $4D, $50] then Stegning;
     END;
   END;   (* IF KeyPressed *)
END;      (*  User         *)


(* * * MAIN * * * * * * * * * * *)
BEGIN
  Assign(f,'SMART.log');
  Assign(textF,'texter.dat');
  Rewrite(f);
  Reset(textF);
  Read(textF,textP);

  check:=0;
  check1:=0;
  IF ParamCount > 0 THEN port:= 2 ELSE port:= 1;
  StartUp;
  BytText;
  HiddenCursor;
  Stegning;
  while tangent <> #27 DO
  begin
    Get;
    User;
    IF sendString Then Transmit;
  end;
  NormalCursor;
  CloseCom(port);
  Close(f);
  Close(textF);
  Window(1,1,80,25);
  NormVideo;
  ClrScr;
END.  (* Smart *)




