UNIT SmartU;

{******************************************}
Interface
  USES TPcRT, asyncX, tpEntry, tpWindow, tpstring, Dos;

  CONST
      FromAsciiMall= '123456789ABCDEF';
      ToAsciiMall  ='0123456789ABCDEF';

TYPE
   TextPost = Record
             namn   : String[14];
             texter : Array[1..10] of String[14];
           end;

  VAR
     w                     : WindowPtr;
     tangent       : CHAR;
     nextText: integer;
     es            : BYTE;          (* Stegar i textrader *)
     stega         : BYTE;

     EER        : ARRAY[1..100] OF string;
     ESR                   : ESrecord;
     ExitCommand           : EStype;
     textP      : textPost;
     textF      : File of textPost;




  FUNCTION TillHex( DER_String : String ): String;
  FUNCTION FromAscii(s: String): BYTE;
  FUNCTION Invertera( s: String ): String;
  FUNCTION Korsa( s: String): STRING;
  FUNCTION Kryss( b: Byte ): Byte;
  PROCEDURE Stegning;
  PROCEDURE BytText;
  PROCEDURE EditFunc;
  FUNCTION Tid : String;

{******************************************}
Implementation


FUNCTION TillHex( DER_String:STRING ): STRING;
VAR
  temp, t1, t2, counter : BYTE;
  outString: STRING;
BEGIN
  outString:='';
  Counter:=0;
  if (length(DER_String) MOD 2 = 0) and(length(DER_String) > 0) then
    REPEAT
      Inc(counter);
      t1:=Pos(DER_string[counter],FromAsciiMall);
      Inc(counter);
      t2:=Pos(DER_string[counter],FromAsciiMall);
      temp:= (t1 SHL 4) + t2;
      outString:=outString + CHR(temp);
    UNTIL counter=Length(DER_string)
    ELSE Writeln(#7,'Felaktig rad...');
  TillHex:= outString;
END;



FUNCTION FromAscii (s:string): BYTE;
VAR  a,b,c: BYTE;
BEGIN
    a:=Pos(s[1],FromAsciiMall);
    b:=Pos(s[2],FromAsciiMall);
    c:=a*16 + b;
    FromAscii:= c;
END;



FUNCTION Invertera( s:string ): STRING;
VAR ny: STRING;
    i : INTEGER;
begin
  ny:= '';
  for i:=1 to length(s) do
  begin
    ny:= ny+ Chr(ord(s[i]) xor 255);
  end;
  Invertera:= ny;
end;


FUNCTION Korsa( s:string ): String;
VAR ny              : STRING;
    i               : INTEGER;
    n,rak,vxl,temp  : byte;
begin
  ny:='';
  for i:=1 to length(s) do
  begin
    vxl:=0;
    temp:=0;
    rak:=ord(s[i]) AND ($01);
    vxl:=rak SHL 7;
    rak:=ord(s[i]) AND ($02);
    vxl:=(vxl) OR (rak SHL 5);
    rak:=ord(s[i]) AND ($04);
    vxl:=(vxl) OR (rak SHL 3);
    rak:=ord(s[i]) AND ($08);
    vxl:=(vxl) OR (rak SHL 1);
    rak:=ord(s[i]) AND ($10);
    vxl:=(vxl) OR (rak SHR 1);
    rak:=ord(s[i]) AND ($20);
    vxl:=(vxl) OR (rak SHR 3);
    rak:=ord(s[i]) AND ($40);
    vxl:=(vxl) OR (rak SHR 5);
    rak:=ord(s[i]) AND ($80);
    vxl:=(vxl) OR (rak SHR 7);
    ny:= ny+ Chr(vxl);
  end;
  Korsa:= ny;
end;

FUNCTION Kryss( b: Byte ): Byte;
VAR
    rak,vxl : Byte;
    i:byte;
begin
  rak:= b AND ($01);
  vxl:=rak SHL 7;
  rak:= b AND ($02);
  vxl:=(vxl) OR (rak SHL 5);
  rak:= b AND ($04);
  vxl:=(vxl) OR (rak SHL 3);
  rak:= b AND ($08);
  vxl:=(vxl) OR (rak SHL 1);
  rak:= b AND ($10);
  vxl:=(vxl) OR (rak SHR 1);
  rak:= b AND ($20);
  vxl:=(vxl) OR (rak SHR 3);
  rak:= b AND ($40);
  vxl:=(vxl) OR (rak SHR 5);
  rak:= b AND ($80);
  vxl:=(vxl) OR (rak SHR 7);
  Kryss:= vxl;
end;


PROCEDURE Stegning;
VAR
   pos : String;
begin
   Str(es:3,pos);
   FastWrite('Rad:'+pos,19,3,$1E);
   Str(stega:3,pos);
   FastWrite('Pos:'+pos,19,14,$1E);
   (* vre strnghalvan *)
   if length(EER[es]) >=72 then
     FastWrite(' '+Copy(EER[es],1,72)+' ',  21,3,$70)
   else begin
     FastFill(74,' ',21,3,$1F);
     FastWrite(' '+EER[es]+' ', 21,3,$70);
   end;
   (* Nedre strnghalvan *)
   if length(EER[es]) >72 then
     FastWrite(' '+Copy(EER[es],73,70)+' ', 22,3,$70)
   else FastFill(74,' ',22,3,$1F);
   (* Markera position *)
   if (stega < 72) and (stega < length(EER[es])) then
     FastWrite(Copy(EER[es],stega,2),21,stega+3,$4E)
   else if (stega >=72) and (stega < length(EER[es])) then
     FastWrite(Copy(EER[es],stega,2),22,(stega-72)+3,$4E)
end;


PROCEDURE BytText;
var i, j, k: integer;
BEGIN
    if (tangent= Chr($49)) and (nextText > 0) then (* PgUp *)
    begin
      dec(nextText);
      seek(textF,nextText);
      read(textF,textP);
    end;
    if (tangent= Chr($51)) and (nexttext < 9) then (* PgDn *)
    begin
      inc(nextText);
      seek(textF,nextText);
      read(textF,textP);
    end;
    FastWrite('              ', 2,60,$1E);
    FastWrite(TextP.namn, 2,60,$1E);
    i:= 1;   j:=1; k:=1;
    for k:=1 to 10 do
    begin
      i:= 1;   j:=1;
      repeat
        if length(textp.texter[k]) >= j then
          FastWrite(TextP.texter[ k][j], 2+k,59+i,$1E)
        else
          FastWrite(' ', 2+k,59+i,$1E);
        if length(textp.texter[k]) >= j+1 then
          FastWrite(TextP.texter[ k][j+1], 2+k,59+i+1,$1e)
        else
          FastWrite('  ', 2+k,59+i+1,$1E);
        inc(i,3);      inc(j,2);
      until i > 19;
   end;
END;


PROCEDURE EditFunc;
  var i: integer;
BEGIN
  IF NOT(AddEntryCommand(ESuser8,1,$4400,$0000)) THEN; (* F10 *)

  IF NOT MakeWindow(w,27,3,48,17,true,true,false,$70,$70,$70,' F10 SPARAR ') then exit;
  IF NOT DisplayWindow(w) THEN exit;

  InitESrecord(ESR);
  WITH textP DO BEGIN
      AddStringField( ESR,'',0,0,'XXXXXXXXXXXXXX',5,30,14,0,nil,namn);
    FOR i:= 1 TO 10 DO
      AddStringField(ESR,'',0,0,'XXXXXXXXXXXXXX',i+6,30,14,0,nil,texter[i]);
    REPEAT
      ExitCommand:=EditScreen(ESR,0,FALSE);
      CASE ExitCommand of
         ESuser8 : BEGIN                    (* F10 Spara *)
                     Seek(textF,filePos(textF)-1);
                     Write(textF,textP);
                     BytText;
                   END;
        ESprevRec: begin
                     IF filepos(textF) > 1  THEN
                     begin
                       seek(textF,filepos(textF)-2);  (* Blddra   *)
                       read(textF,textP);
                     end;
                   end;
        ESnextRec: begin
                     IF filepos(textF) < 10 then read(textF,textP);
                   end;
     END;
    UNTIL ExitCommand=ESquit;
  END; (* With textP *)
  DisposeEditScreen(ESR);
  DisposeWindow(EraseTopWindow);
END;    (* Editfunc *)

FUNCTION Tid : String;
VAR h,m,s,hu : WORD;
       a,b,c : STRING[2];
BEGIN
   GetTime(h,m,s,hu);
   Str(h,a);   Str(m,b);  Str(s,c);
   IF h < 10 THEN a:= '0'+ a;
   IF m < 10 THEN b:= '0'+ b;
   IF s < 10 THEN c:= '0'+ c;
   tid:=(a+':'+b+':'+c);
END;

begin
  EER[1]:='DF00E1041B690404EA1011CD75132F301EA5428675AEBEA63F7AF0083E3B8500426599F3CAC0000012';
  EER[2]:='F893B90F79FB9A8A1569C3BE171717171717171731313131313131281553390900';
  EER[3]:='CAA4000000CAA4000000CA24000009000000000000000000CAA4040003000410';
  EER[4]:='CAACA50000CAB800006A504122F5CD2';
  EER[5]:='CAA4000000CA24000009000000000000000004CAA4000000CAAAA70000CAB8000012';
  EER[6]:='CAA4020000CAACA70000CAB8000012';
  EER[7]:='CAA4020000CAA4000000CAA4020000CAACA70000CAB8000012';
  EER[8]:='CAACAC0000CAACB10000CAB80000060400000000CAACB20000CAB8000006B20400000000';
  EER[9]:='CAACAD0000CAA4000000CAA4020000CAACA70000CAB8000012CAACA800040021FE21';
  EER[10]:='CAB800008';
  EER[11]:='CAB8000008';
  EER[12]:='F893A5C1F7BF9F44A27A30CECEFBFBFBFBFBFBFBABABABABABABAB897BA8EDB00';
  EER[13]:='E89395D2F3339F77299D798B8B8B8B8B8B8B8B8B8B8B8B8B212121A56FEDF4AFF';
  EER[14]:='F893AD451FC59AC041259A848484846D6D6D6D6D6D6D4B4B4BB8B8DBAB6CF7140';
  EER[15]:='F893991429AD9A91EA4C72B6B6B6B6D6D6D6D6D64D4D4D424242700E846D35B10';
  EER[16]:='F893A7F096779A750AA2D79AF5F5F5F5F5F54C4C4C4C4C4C4C4C079343164F7A0';
  EER[17]:='F893B90F58979A8A15E9EF484848F3F333333333333333333333337CA2AAC4AF0';
  EER[18]:='F89397EB8FBD9A6E855B6D31313131319F9FBEBEBE848484C8C8C819024ACB330';
  EER[19]:='E893B18B2E479A2ED690E5646464649935EFEFEFEFEFEFEFEFEF59983B7F46970';
  EER[20]:='F893B90F0AE99F8A15E971DADADADADADADADADA979797929292924A3B0A11AA0';
  EER[21]:='F893AD4527199FC041A55B474747479292929292646464B0B023236D4B9CF7FB0';
  EER[22]:='F893AD456DE99FC041A5D3C4C4C4C4C4DCDCDC2B2B2B8C8C8C8C8C4103FB88C60';
  EER[23]:='F893A1823D959F07535272EBEBEBEBEB5B5B5B5B5B5B5B5B3E3E3E83E23A23CF0';
  EER[24]:='F893AF7472AD9FF1B1C392FCFC0C0C0C0C0C0C0C0C0C0C0CF42323F16BB761290';
  EER[25]:='E893819E82DD9F3B5ED7A73333333333323206064A4A3030303030A223D97CAB0';
  EER[26]:='F893A3B3A14D9A36EB2E9B97979797979797979783838383838383FB619F0D030';
  EER[27]:='F8938D5BD7299ADE4C6207C2C2C2C2C2E6E6E60404646464525252B9AA158BC20';
  EER[28]:='F893819E38279A1B5ED7FD262626262626262626262619666666B5668D7F63D00';
  EER[29]:='F89387E2B1779A6700A74133333333339E9E9E9E9E9E9E9E9E9E9ED0F92834690';
  EER[30]:='F893B90F70279A8A15090BF5F5F5F54E4E4E4EA7A7A7A7A7A7A7A70033CB9FC10';
  EER[31]:='E893A7F06D279A550A42778989CCB6B6B63131310D777777777777C0BFCCCEA30';
  EER[32]:='12121212';
end.